package SAML::SPMetadata::KeyDescriptor ;

# We bend the variable naming convention in some cases since we want the
# variable name to match the XML attribute name:
## no critic (NamingConventions::Capitalization)

# Perl object to represent a certificate used in an SP metadata XML
# string.

use strict ;
use warnings ;
use autodie ;

# Make this a Moose class
use Moose ;
use namespace::autoclean;

has X509Certificates => (
  is        => 'rw',
  isa       => 'ArrayRef[SAML::SPMetadata::X509Certificate]',
  required  => 1,
    ) ;

# Allow undef
has usage => (
  is        => 'rw',
  isa       => 'Maybe[Str]',
  required  => 0,
    ) ;

sub to_hash {
    my $self = shift ;

    my %hash = () ;
    $hash{'usage'} = $self->usage() ;

    my @certs = () ;
    my @X509Certificates = @{ $self->X509Certificates() } ;
    foreach my $X509Certificate (@X509Certificates) {
        push(@certs, $X509Certificate->to_hash()) ;
    }
    $hash{'X509Certificates'} = \@certs ;

    return \%hash ;
}

1;
